/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TCentralComponent.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TCentralComponent::TCentralComponent() : Component("Central Component"),
                                         pColourLabel(0),
                                         pChooseButton(0)
{
    pColourLabel = new Label(L"Colour Label", tr("ВЫБРАННЫЙ ЦВЕТ ФОНА"));
    pColourLabel->setFont(Font(15.0000f, Font::bold));
    pColourLabel->setJustificationType(Justification::centred);
    pColourLabel->setEditable(false, false, false);
    pColourLabel->setColour(Label::textColourId, Colours::black);
    pColourLabel->setColour(Label::backgroundColourId, Colours::azure);
    pColourLabel->setColour(Label::outlineColourId, Colours::black);
    addAndMakeVisible(pColourLabel);
    
    pChooseButton = new TextButton(L"Choose Button");
    pChooseButton->setButtonText(tr("Выбрать..."));
    pChooseButton->addListener(this);
    addAndMakeVisible(pChooseButton);

    setSize (400, 150);
}
//---------------------------------------------------------------------
TCentralComponent::~TCentralComponent()
{
    // Удаляем дочерние виджеты
    // и обнуляем их указатели
    deleteAllChildren();
}
//---------------------------------------------------------------------
void TCentralComponent::paint(Graphics& Canvas)
{
    Canvas.fillAll(Colours::azure);
}
//---------------------------------------------------------------------
void TCentralComponent::resized()
{
    pColourLabel->setBounds(10, 10, getWidth() - 20, 25);
    pChooseButton->setBounds(proportionOfWidth(0.5000f) - ((150) / 2), proportionOfHeight(0.5000f) - ((25) / 2), 150, 25);
}
//---------------------------------------------------------------------
void TCentralComponent::buttonClicked(Button* pButton)
{
    if(pButton == pChooseButton)
    {
        // Создаём виджет выбора цвета
        ColourSelector* pColourDialog = new ColourSelector();
        // и устанавливаем его размер
        pColourDialog->setSize(600, 400);

        // Показываем диалог с созданным виджетом
        DialogWindow::showModalDialog(tr("Выбор цвета"),
                                      pColourDialog,
                                      NULL,
                                      Colours::azure,
                                      true,
                                      false,
                                      false);
 
        // Сохраняем текущий цвет виджета в переменной 
        // после закрытия диалога
        Colour CurrentColour = pColourDialog->getCurrentColour();
        // Присваиваем этот цвет ярлыку
        pColourLabel->setColour(Label::backgroundColourId, CurrentColour);

        if(pColourDialog) delete pColourDialog;
    }
}
//---------------------------------------------------------------------

