/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TCentralComponent.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TCentralComponent::TCentralComponent() : Component("Central Component"),
                                         pInfoLabel(0),
                                         pQuestionButton(0)
{
    // Ярлык для вывода информационного сообщения
    pInfoLabel = new Label(L"Info Label", tr("Нажмите на кнопку, чтобы начать..."));
    pInfoLabel->setFont(Font(15.0000f, Font::bold));
    pInfoLabel->setJustificationType(Justification::centred);
    pInfoLabel->setEditable(false, false, false);
    pInfoLabel->setColour(Label::textColourId, Colours::black);
    pInfoLabel->setColour(Label::backgroundColourId, Colours::azure);
    pInfoLabel->setColour(Label::outlineColourId, Colours::black);
    addAndMakeVisible(pInfoLabel);

    // Кнопка вызова диалогового окна
    pQuestionButton = new TextButton(L"Question Button");
    pQuestionButton->setButtonText(tr("Задать вопрос..."));
    pQuestionButton->addListener(this);
    addAndMakeVisible(pQuestionButton);

    setSize (400, 150);
}
//---------------------------------------------------------------------
TCentralComponent::~TCentralComponent()
{
    // Удаляем дочерние виджеты
    // и обнуляем их указатели
    deleteAllChildren();
}
//---------------------------------------------------------------------
void TCentralComponent::paint(Graphics& Canvas)
{
    Canvas.fillAll(Colours::azure);
}
//---------------------------------------------------------------------
void TCentralComponent::resized()
{
    pInfoLabel->setBounds(10, 10, getWidth() - 20, 25);
    pQuestionButton->setBounds(proportionOfWidth(0.5000f) - ((150) / 2), proportionOfHeight(0.5000f) - ((25) / 2), 150, 25);
}
//---------------------------------------------------------------------
void TCentralComponent::buttonClicked(Button* pButton)
{
    if(pButton == pQuestionButton)
    {
        // Сообщение пользователю
        String sMessage = String::empty;
        
        // Задаём вопрос - вызываем диалоговое окно
        bool bAnswer = AlertWindow::showOkCancelBox(AlertWindow::QuestionIcon, 
                                                    tr("Примета"), 
                                                    tr("Верите ли Вы в приметы?"), 
                                                    tr("Да"), 
                                                    tr("Нет"), 0);
        
        // Если да... 
        if(bAnswer)
        {
            // формируем сообщение, которое будет выводиться красным цветом
            sMessage = tr("Верить в приметы - плохая примета!");
            pInfoLabel->setColour(Label::textColourId, Colours::red);
        }
        // Если нет...
        else
        {
            // формируем сообщение, которое будет выводиться синим цветом
            sMessage = tr("Поздравляю, Вы - очень разумный человек!");
            pInfoLabel->setColour(Label::textColourId, Colours::blue);
        }
        
        // Показываем сообщение
        pInfoLabel->setText(sMessage, false);
    }
}
//---------------------------------------------------------------------

